#
# spec file for package xv
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%if "%{_exec_prefix}" == "%{_prefix}/X11R6"
%global _mandir     %{_prefix}/man
%define _x11data    %{_prefix}/lib/X11
%define _libx11     %{_x11data}
%else
%define _x11data    %{_datadir}/X11
%define _libx11     %{_prefix}/lib/X11
%endif
Name:           xv
Version:        3.10a
Release:        1280.3.1
Summary:        GIF/TIFF/JPEG/PostScript Image Viewer
License:        SUSE-NonFree
Group:          Productivity/Graphics/Viewers
Url:            http://www.trilon.com/xv/
Source:         xv-3.10a.tar.bz2
#Url http://www.gregroelofs.com/greg_xv.html
Source1:        xv-3.10a-jumbo-patches-20070520.tar.bz2
Source2:        xsetbgimg
Source3:        xv.desktop
Source4:        xv.png
Source5:        xv-tests.tar.bz2
Patch0:         xv-3.10a.dif
Patch1:         xv-3.10a-ticks.dif
Patch2:         xv-3.10a-signal.dif
Patch3:         xv-3.10a-overflow.dif
Patch4:         xv-3.10a-jpeg8.dif
Patch5:         xv-3.10a-png.dif
Patch6:         xv-3.10a-xwd.dif
Patch7:         xv-3.10a-dirw.dif
Patch8:         xv-3.10a-enhancements.20070520-20081216.diff
Patch9:         xv-3.10a-libpng15.patch
Patch10:        xv-3.10a-png-gimp.patch
BuildRequires:  dos2unix
BuildRequires:  groff
BuildRequires:  libjpeg-devel
BuildRequires:  libpng-devel
BuildRequires:  libtiff-devel
BuildRequires:  update-desktop-files
BuildRequires:  xorg-x11-devel
BuildRequires:  zlib-devel
Provides:       xv300
%{expand: %%global _exec_prefix %(type -p pkg-config &>/dev/null && pkg-config --variable prefix x11 || echo %{_prefix}/X11R6)}

%description
XV is an interactive image viewer for the X Window System. XV displays
images in GIF, JPEG, TIFF, PNG, PBM, PGM, PPM, X Window System bitmap,
Utah Raster Toolkit RLE, PDS/VICAR, Sun Rasterfile, BMP, PCX, IRIS RGB,
XPM, Targa, XWD, possibly PostScript, and PM formats on workstations
and terminals running the X Window System Version 11.

XV can also manipulate pictures. It can zoom in and out, rotate, and
flip them. It also provides a wide variety of operations to modify
colors.

It is one of the most famous programs for Linux.

The documentation can be found in %{_docdir}/xv/.

Please remember that this program has shareware status for commercial
use.

%prep
%setup -q -b1
 patch  -p1 -s --suffix=.jumbo-20070520 < ../xv-3.10a-jumbo-fix-enh-patch-20070520.txt
%patch8  -b .jumbo-20081216
%patch1  -b .ticks
%patch2  -b .sig
%patch3  -b .ovf
%patch4  -b .jpg8
%patch5  -b .png
%patch6  -b .xwd
%patch7  -b .dirw
%patch9  -b .libpng5
%patch0
%patch10 -p1 -b .png-gimp

%build
# Do not overwrite CFLAGS here
RPM_OPT_FLAGS="%{optflags} -D_GNU_SOURCE -fno-strict-aliasing -pipe -fstack-protector"
xmkmf -a
make %{?_smp_mflags}

%install
mv docs/README docs/README.docs
%make_install
make install.man DESTDIR=%{buildroot}
rm docs/*._man
mkdir man
for m in docs/*.man; do
 test -e $m || continue
 troff -Tlatin1 -t -mandoc < $m | grotty -bou > ${m%.*}.txt
 mv $m man/
done
ln -sf README COPYRIGHT
if test -e docs/xvdocs.pdf ; then
 rm -vf docs/xvdocs.ps
fi
if test -e docs/xvtitle.ps ; then
 cp -p docs/xvtitle.ps tmp.ps
 dos2unix docs/xvtitle.ps
 touch -r tmp.ps docs/xvtitle.ps
fi
install -m 755 %{SOURCE2} %{buildroot}%{_bindir}/xsetbgimg
rm -f %{buildroot}%{_libx11}/xv_mgcsfx.sample
%suse_update_desktop_file -i xv Graphics Viewer

%files
%defattr(-,root,root)
%doc README.jumbo README.pcd README
%doc COPYRIGHT docs/*
%{_datadir}/applications/xv.desktop
%{_datadir}/pixmaps/xv.png
%{_bindir}/bggen
%{_bindir}/vdcomp
%{_bindir}/xcmap
%{_bindir}/xsetbgimg
%{_bindir}/xv
%{_bindir}/xvpictoppm
%{_mandir}/man1/bggen.1x%{ext_man}
%{_mandir}/man1/vdcomp.1x%{ext_man}
%{_mandir}/man1/xcmap.1x%{ext_man}
%{_mandir}/man1/xv.1x%{ext_man}
%{_mandir}/man1/xvpictoppm.1x%{ext_man}

%changelog
* Sat Jun 10 2017 mpluskal@suse.com
- Cleanup spec file with spec-cleaner
* Thu Jun  8 2017 rich.coe2@gmail.com
- correctly calculate size of string buffer in png data (bnc#1043479)
  * xv-3.10a-png-gimp.patch
* Tue May 14 2013 pgajdos@suse.com
- build require libpng-devel => build against libpng16 in factory
* Mon Mar 11 2013 werner@suse.de
- Change licence string to be conform with http://license.opensuse.org/
* Mon Nov  5 2012 werner@suse.de
- Required groff at build time
* Mon Oct 15 2012 werner@suse.de
- Add patch for libpng15 support
* Fri Oct 12 2012 werner@suse.de
- Use libpng14-devel and libpng14-compat-devel to make it build
* Mon May 21 2012 burnus@net-b.de
- Install the correct README file (bnc#763240)
* Fri Mar 16 2012 werner@suse.de
- Add libjpeg-devel to resolve missing jpeglib.h
* Wed Nov  2 2011 werner@suse.de
- Do not overwrite base name buffer in wrong order  (bnc#722130)
* Thu Jul  7 2011 werner@suse.de
- Copy always not more as the length of the buffers for the
  filenames and the basename of them (bnc#704230)
* Tue Dec 15 2009 werner@suse.de
- Update to jumbo patch enhancment 20081216 from Greg Roelofs.
- Forward my patches to Greg Roelofs.
- Add my further test cases to xv-tests.tar.bz2
- Add a notify warning about the risks of using XV in the
  package data base
* Tue Jun 23 2009 werner@suse.de
- In DirW do not move cursor if no filename is there (bnc#506573)
* Wed Oct  8 2008 werner@suse.de
- Make code of xwd work (bnc#426582)
* Wed Sep  3 2008 werner@suse.de
- Do not deleted PNG window twice (bnc#419422)
* Fri Aug  1 2008 werner@suse.de
- In jpeg library the numbers of out_color_components and
  color_components are diffenrent for quantize_colors, that is
  that color_components is the colormap (normally 1) (bnc#412491)
* Tue May 27 2008 werner@suse.de
- Switch over to jumbo patch 20070520 as this includes not only
  all of our security patches but also those from debian
- Avoid to be fooled on new gcc as the overflow detection with
  signed integers hadn't worked anymore
- Avoid to be fooled on boundary check of new glibc on counting
  the pointer up and behind the upper boundary
* Fri May 23 2008 werner@suse.de
- Never call X11 functions from within siganl handler (bnc#283914)
* Thu Jul  5 2007 coolo@suse.de
- put desktop file and icon into package
* Mon Jan 29 2007 werner@suse.de
- Be sure to use system ticks (bug #237214)
* Fri Jan 12 2007 werner@suse.de
- Catch compiler warnings
* Thu Jan 11 2007 werner@suse.de
- Catch BadAcsess in XGrabButton for fvwm2 (report from Reinhard)
* Wed Aug  2 2006 werner@suse.de
- Make it build with X11R7
* Mon May 29 2006 werner@suse.de
- Allow NumLock (and any other modifier) for grab (bug #179310)
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Thu Jan 12 2006 werner@suse.de
- Use the gcc stack protector
* Mon Dec  5 2005 werner@suse.de
- Add workarounds to catch race in XGrabButton under KDE (#133406)
* Wed Apr 13 2005 werner@suse.de
- Yet an other security fix
* Mon Apr 11 2005 werner@suse.de
- Update to final jumbo patch 20050410
* Mon Apr 11 2005 werner@suse.de
- Fix for compressed mac binaries
* Fri Apr  8 2005 werner@suse.de
- Use fix+enh patch from GRR (security)
- Correct bmp driver for smaller bpp values
- Adapt and use newer Japanese extension patch
* Fri Mar  4 2005 werner@suse.de
- Fix format string error (bug #70844)
* Wed Nov 17 2004 werner@suse.de
- Add xv.png pixmap to file list
* Tue Aug 24 2004 werner@suse.de
- Fix know overflows caused by bogus images (bug #44120)
* Wed Jul 28 2004 werner@suse.de
- Add mouse wheel patch from Yue Shi Lai <yl2160@columbia.edu>
- Add bmp 32 bit extension also provided by Yue Shi Lai
* Wed Jun  9 2004 werner@suse.de
- Fix 24bit issue of bmp format to make 24bit bmp visible again
  (was introduced by fix of bug #20120) (bug# 41849)
* Tue Feb 24 2004 werner@suse.de
- Remove nasty compile warning
- Convert manual pages under doc to text files
* Thu Feb 12 2004 werner@suse.de
- Never overwrite CFLAGS of a imaked Makefile
* Tue Feb  3 2004 kukuk@suse.de
- Build with -fno-strict-aliasing
* Sat Jan 10 2004 adrian@suse.de
- build as user
* Sun Aug 17 2003 adrian@suse.de
- added desktop file
* Tue Apr 15 2003 coolo@suse.de
- use BuildRoot
* Sun Jan 26 2003 ro@suse.de
- fix imakefile
* Wed Sep 25 2002 werner@suse.de
- Support BMP even if padding is broken (bug #20120)
* Tue Aug 20 2002 werner@suse.de
- Warning added: MAKI is only supported with 640x400 (bug #18093)
* Thu Aug 15 2002 werner@suse.de
- Fix timing/refresh problem of xv with XFree86[tm]-4.2
* Sat Jul 27 2002 adrian@suse.de
- fix neededforbuild
* Fri Feb 15 2002 ro@suse.de
- fix owner/group after unpacking all sources
* Tue Feb 12 2002 kukuk@suse.de
- Use correct tar option
* Thu Jan 31 2002 ro@suse.de
- changed neededforbuild <libpng> to <libpng-devel-packages>
* Tue Aug 21 2001 cstein@suse.de
- added some sanity checking to 'xsetbgimg'
* Fri Jul  6 2001 cstein@suse.de
- added 'xsetbgimg', a small shell script to set the X background
  quickly (calls xv)
* Tue May  8 2001 mfabian@suse.de
- bzip2 sources
* Tue Jun  6 2000 werner@suse.de
- Correct last change
* Sat May 27 2000 kukuk@suse.de
- Use %%doc macro for documentation
* Wed Jan 12 2000 werner@suse.de
- Better dithering of TrueColor pictures on 16bit displays
* Tue Sep 28 1999 werner@suse.de
- Temporay files writable and readable for the owner
* Thu Sep 23 1999 werner@suse.de
- Make temporay file creation more secure
  * Use vdroot for tmpdir if AUTOEXTRACT is defined
  * Try to open with O_WRONLY|O_CREAT|O_EXCL first
  * Unsolved: gs and pic2 output page files (%%d)
  - Use better visual detection for 24 bit displays
  - Expand tiff handling
  * more than the first page is viewable
  * handle LZW compression
* Wed Sep 22 1999 werner@suse.de
- Add some boundary checks
  - Add pdf support via gs
  - Fix hints handling (flags initialized to zero)
  - Fix grabbing
  - Fix gif for deep colours spaces
* Mon Sep 13 1999 bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Sun Nov 29 1998 bs@suse.de
- don't compile with -fno-force-mem
* Wed Nov  4 1998 werner@suse.de
- Add jap patch for new formats
  - Erase remaining pixels of a not fitting line (XPM)
  - Some security fixes
* Thu Sep 17 1998 ro@suse.de
- don't redeclare sys_errlist for glibc
* Wed Nov  5 1997 werner@suse.de
- Added png support
* Fri Oct 17 1997 ro@suse.de
- added -lz after -ltiff
* Fri Feb 14 1997 werner@suse.de
- Good old xv new packed
  - Including some fixes for xv-3.10a
  - Fix a bug in writing xpm
  - Use shared lib's: libtiff.so.3, libjpeg.so.5, libgz.so.1
  - Enable ghostscript and gunzip
